'From Squeak3.8 of ''5 May 2005'' [latest update: #6665] on 29 August 2005 at 8:25:22 am'!
"Change Set:		OmniBase-ByteArrayKeyPatch
Date:			29 August 2005
Author:			Masashi Umezawa

OmniBase Squeak raises an error when trying to register object with ByteArray key.

This is obviously caused by a typo in Object class >> odbLoadVariables:classInfo:. 'self class isWords' should be 'self isWords', because it is useless to ask metaclass 'isWords'. 
"!

TestCase subclass: #OmniBaseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBaseJ-Test'!
OmniBaseTest class
	instanceVariableNames: 'testDirPath'!

!Object class methodsFor: '*omnibase' stamp: 'mu 8/29/2005 08:11'!
odbLoadVariables: deserializer classInfo: classInfo

	| stream order iSize object basicSize varArray |
	stream := deserializer stream.
	classInfo isVariable
		ifTrue: [ object := self basicNew: (basicSize := stream getPositiveInteger) ]
		ifFalse: [
			basicSize := 0.
			object := self basicNew.
		].
	deserializer register: object.
	classInfo isBytes ifTrue: [
		self isWords 
			ifTrue: [1 to: basicSize do: [:i | object basicAt: i put: stream getInteger]]
			ifFalse: [stream getBytesFor: object len: basicSize].
		^object
	].
	varArray := Array new: (iSize := classInfo realInstSize) + 1.
	order := classInfo variableOrder.
	1 to: classInfo instSize do: [:i | varArray at: (order at: i) put: deserializer odbNextObject ].
	1 to: iSize do: [:i | object instVarAt: i put: (varArray at: i) ].
	iSize + 1 to: iSize + basicSize do: [:i | object instVarAt: i put: deserializer odbNextObject ].
	^object odbDeserialized: deserializer! !


!OmniBaseTest methodsFor: 'actions' stamp: 'mu 8/29/2005 08:16'!
doWhileDbOpening: aBlock 
	| db |
	^[db := self openedDb.
	aBlock value: db]
		ensure: [db close]! !

!OmniBaseTest methodsFor: 'accessing' stamp: 'mu 8/29/2005 08:16'!
openedDb
	^self class openedDb
	! !

!OmniBaseTest methodsFor: 'Testing' stamp: 'mu 8/29/2005 08:16'!
testStoreLoadByteArrayKey
	"self debug: #testStoreLoadByteArrayKey"
	self
		doWhileDbOpening: [:db | 
			| key stored | 
			[key := 'bytes' asByteArray.
			OmniBase root at: key put: #test]
				evaluateAndCommitIn: db newTransaction.
			stored := db newTransaction root at: key.
			self
				should: [stored = #test]]! !


!OmniBaseTest class methodsFor: 'class initialization' stamp: 'mu 8/29/2005 08:16'!
initialize
	"OmniBaseJTest initialize"
	testDirPath _ nil.
	Smalltalk addToShutDownList: self! !

!OmniBaseTest class methodsFor: 'class initialization' stamp: 'mu 8/29/2005 08:16'!
obsolete
	Smalltalk removeFromShutDownList: self! !

!OmniBaseTest class methodsFor: 'defaults' stamp: 'mu 8/29/2005 08:16'!
defaultDbSubDirName
	^'omniBaseTestDb' copy! !

!OmniBaseTest class methodsFor: 'defaults' stamp: 'mu 8/29/2005 08:16'!
defaultDirectory
	| subDirName |
	subDirName := self defaultDbSubDirName.
	(FileDirectory default directoryExists: subDirName)
		ifFalse: [FileDirectory default createDirectory: subDirName].
	^ FileDirectory default directoryNamed: subDirName! !

!OmniBaseTest class methodsFor: 'defaults' stamp: 'mu 8/29/2005 08:16'!
testDirPath
	testDirPath ifNil: [testDirPath _ self defaultDirectory fullName].
	^testDirPath! !

!OmniBaseTest class methodsFor: 'shutting down' stamp: 'mu 8/29/2005 08:16'!
shutDown
	self deleteDb! !

!OmniBaseTest class methodsFor: 'accessing' stamp: 'mu 8/29/2005 08:16'!
createDb
	| db |
	[db := OmniBase createOn: self testDirPath]
		ensure: [db close]! !

!OmniBaseTest class methodsFor: 'accessing' stamp: 'mu 8/29/2005 08:16'!
deleteDb
	"self deleteDb"
	OmniBase closeAll.
	self defaultDirectory recursiveDelete! !

!OmniBaseTest class methodsFor: 'accessing' stamp: 'mu 8/29/2005 08:16'!
openedDb
	"self openedDb"
	| retry db |
	retry := 0.
	[db := OmniBase openOn: self testDirPath]
		on: ODBError
		do: [:ex | 
			retry _ retry + 1.
			retry > 1
				ifTrue: [ex pass].
			self createDb.
			ex retry].
	^ db! !

OmniBaseTest initialize!

!OmniBaseTest reorganize!
('actions' doWhileDbOpening:)
('accessing' openedDb)
('Testing' testStoreLoadByteArrayKey)
!

